;===========================================================================================
; CControls.asm  GoAsm assembler
; Common Controls
; Programm par AsmGges France
;===========================================================================================
; compile.bat:
; ..\..\bin\GoRC /r, res\ccontrols.rc
; ..\..\bin\GoAsm ccontrols.asm
; ..\..\bin\GoLink ccontrols.obj res\ccontrols.res user32.dll kernel32.dll gdi32.dll 
;                                                                       comctl32.dll
;===========================================================================================

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  #include "..\..\inc\Windows.inc"
  #include "..\..\inc\all_api.inc"

  ID_FRANCE  = 17

  IDM_MENU   = 600
  ID_EXIT    = 1000
  ID_ABOUT   = 1100

;===========================================================================================
; Dbut du code programme
; -----------------------
.code

  start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Charge une icne spcifique
    ; ---------------------------
    invoke LoadIcon,[wc.hInstance],ID_FRANCE
    mov [wc.hIcon],eax

    ; Charge un curseur systme
    ; -------------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Charge un menu
    ; --------------
    invoke  LoadMenu,[wc.hInstance],IDM_MENU
    mov [hMenu],eax

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Valider la structure WNDCLASS
    ; -----------------------------
    invoke RegisterClass,addr wc

    ; Cration de la fenetre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,WS_EX_LEFT,addr ClassName,addr Titre,WS_OVERLAPPEDWINDOW,\
                            [WinX],[WinY],[WinW],[WinH],0,[hMenu],[wc.hInstance],0
    mov [hWnd],eax

    ; Affiche et rafraichit la fenetre
    ; --------------------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT
    invoke UpdateWindow,[hWnd]

 ; Boucle des messages
 ; -------------------
 MessageLoop:
    invoke GetMessage,addr msg,0,0,0
    or eax,eax
    jz >ExitProgram
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
    jmp <MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
WindowProc frame @hWnd, @uMsg, @wParam, @lParam
    uses ebx,esi,edi
    local .caW:D
    local .caH:D

    cmp D[@uMsg],WM_CLOSE
    jne >.wmdestroy
        invoke MessageBox,[@hWnd],addr TheText,addr ClassName,MB_YESNO
        cmp eax,IDYES
        jne >>.exit
            ; Demande fin d'application
            ; -------------------------
            invoke PostQuitMessage,NULL        
            jmp >>.exit

    .wmdestroy:
    cmp D[@uMsg],WM_DESTROY
    jne >.wmcommand
        invoke PostQuitMessage,NULL
        jmp >>.exit

    .wmcommand:
    cmp D[@uMsg],WM_COMMAND
    jne >>.wmcreate
        ; Commandes de la barre d'outils
        ; ------------------------------
        cmp D[@wParam],50
        jne >
            mov eax,addr tb50
            jmp >>.toolbarmsg
        :
        cmp D[@wParam],51
        jne >
            mov eax,addr tb51
            jmp >>.toolbarmsg
        :
        cmp D[@wParam],52
        jne >
            mov eax,addr tb52
            jmp >>.toolbarmsg
        :
        cmp D[@wParam],53
        jne >
            mov eax,addr tb53
            jmp >>.toolbarmsg
        :
        cmp D[@wParam],54
        jne >
            mov eax,addr tb54
            jmp >>.toolbarmsg
        :
        cmp D[@wParam],55
        jne >
            mov eax,addr tb55
            jmp >.toolbarmsg
        :
        cmp D[@wParam],56
        jne >
            mov eax,addr tb56
            jmp >.toolbarmsg
        :
        cmp D[@wParam],57
        jne >
            mov eax,addr tb57
            jmp >.toolbarmsg
        :
        cmp D[@wParam],58
        jne >
            mov eax,addr tb58
            jmp >.toolbarmsg
        :
        cmp D[@wParam],59
        jne >
            mov eax,addr tb59
            jmp >.toolbarmsg
        :
        ; Commandes de menu
        ; -----------------
        cmp D[@wParam],ID_EXIT
        jne >
            invoke SendMessage,[@hWnd],WM_SYSCOMMAND,SC_CLOSE,NULL
            jmp >>.exit
        :
        cmp D[@wParam],ID_ABOUT
        jne >>.exit
            invoke MessageBox,[@hWnd],addr MsgAbout,addr ClassName,MB_OK
            jmp >>.exit

        .toolbarmsg:
        push eax
        invoke MessageBox,[@hWnd],eax,addr tbSelect,MB_OK
        pop eax
        invoke SendMessage,[hStatus],SB_SETTEXT,0,eax
        jmp >>.exit

    .wmcreate:
    cmp D[@uMsg],WM_CREATE
    jne >>.wmsize
        mov D[icex.dwSize],sizeof INITCOMMONCONTROLSEX
        mov D[icex.dwICC],0FFFFh
        invoke InitCommonControlsEx,addr icex

        ; Cration de la barre d'outils
        ;------------------------------
        mov D[tbb.iBitmap],0
        mov D[tbb.idCommand],0
        mov D[tbb.fsState],TBSTATE_ENABLED
        mov D[tbb.fsStyle],TBSTYLE_SEP
        mov D[tbb.dwData],0
        mov D[tbb.iString],0

        invoke CreateToolbarEx,[@hWnd],WS_CHILD+WS_CLIPSIBLINGS,300,1,0,0,addr tbb,\
                                                       1,16,16,0,0,sizeof TBBUTTON

        mov [hToolBar],eax
        invoke ShowWindow,[hToolBar],SW_SHOW

        mov D[Tba.hInst],HINST_COMMCTRL
        mov D[Tba.nID],2   ; btnsize 1=grande 2=moyenne

        invoke SendMessage,[hToolBar],TB_ADDBITMAP,1,addr Tba

        ; Boutons pour la barre d'outils
        ;-------------------------------
        mov D[tbb.iBitmap],STD_FILENEW
        mov D[tbb.fsStyle],TBSTYLE_BUTTON
        mov D[tbb.idCommand],50
        invoke SendMessage,[hToolBar],TB_ADDBUTTONS,1,addr tbb

        mov D[tbb.iBitmap],STD_FILEOPEN
        mov D[tbb.idCommand],51
        mov D[tbb.fsStyle],TBSTYLE_BUTTON
        invoke SendMessage,[hToolBar],TB_ADDBUTTONS,1,addr tbb

        mov D[tbb.iBitmap],STD_FILESAVE
        mov D[tbb.idCommand],52
        mov D[tbb.fsStyle],TBSTYLE_BUTTON
        invoke SendMessage,[hToolBar],TB_ADDBUTTONS,1,addr tbb

        mov D[tbb.idCommand],0
        mov D[tbb.fsStyle],TBSTYLE_SEP
        invoke SendMessage,[hToolBar],TB_ADDBUTTONS,1,addr tbb

        mov D[tbb.iBitmap],STD_CUT
        mov D[tbb.idCommand],53
        mov D[tbb.fsStyle],TBSTYLE_BUTTON
        invoke SendMessage,[hToolBar],TB_ADDBUTTONS,1,addr tbb

        mov D[tbb.iBitmap],STD_COPY
        mov D[tbb.idCommand],54
        mov D[tbb.fsStyle],TBSTYLE_BUTTON
        invoke SendMessage,[hToolBar],TB_ADDBUTTONS,1,addr tbb

        mov D[tbb.iBitmap],STD_PASTE
        mov D[tbb.idCommand],55
        mov D[tbb.fsStyle],TBSTYLE_BUTTON
        invoke SendMessage,[hToolBar],TB_ADDBUTTONS,1,addr tbb

        mov D[tbb.iBitmap],STD_UNDO
        mov D[tbb.idCommand],56
        mov D[tbb.fsStyle],TBSTYLE_BUTTON
        invoke SendMessage,[hToolBar],TB_ADDBUTTONS,1,addr tbb

        mov D[tbb.iBitmap],0
        mov D[tbb.idCommand],0
        mov D[tbb.fsStyle],TBSTYLE_SEP
        invoke SendMessage,[hToolBar],TB_ADDBUTTONS,1,addr tbb

        mov D[tbb.iBitmap],STD_FIND
        mov D[tbb.idCommand],57
        mov D[tbb.fsStyle],TBSTYLE_BUTTON
        invoke SendMessage,[hToolBar],TB_ADDBUTTONS,1,addr tbb

        mov D[tbb.iBitmap],STD_REPLACE
        mov D[tbb.idCommand],58
        mov D[tbb.fsStyle],TBSTYLE_BUTTON
        invoke SendMessage,[hToolBar],TB_ADDBUTTONS,1,addr tbb

        mov D[tbb.iBitmap],0
        mov D[tbb.idCommand],0
        mov D[tbb.fsStyle],TBSTYLE_SEP
        invoke SendMessage,[hToolBar],TB_ADDBUTTONS,1,addr tbb

        mov D[tbb.iBitmap],STD_PRINT
        mov D[tbb.idCommand],59
        mov D[tbb.fsStyle],TBSTYLE_BUTTON
        invoke SendMessage,[hToolBar],TB_ADDBUTTONS,1,addr tbb

        ; Cration de la barre de status
        ;-------------------------------
        invoke CreateStatusWindow,WS_CHILD+WS_VISIBLE+SBS_SIZEGRIP,0,[@hWnd],200
        mov [hStatus],eax
        jmp >>.exit

    .wmsize:
    cmp D[@uMsg],WM_SIZE
    jne >.wmpaint
        invoke SendMessage,[hToolBar],TB_AUTOSIZE,0,0

        mov eax,[@lParam]
        mov [.caW],eax  ; largeur de la fenetre client
        mov eax,[@lParam]
        mov [.caH],eax  ; hauteur de la fenetre client

        invoke GetWindowRect,[hStatus],addr rect
        mov eax,[rect.bottom]
        sub eax,[rect.top]
        sub [.caH],eax

        invoke MoveWindow,[hStatus],0,[.caH],[.caW],[.caH],TRUE
        jmp >.exit

    .wmpaint:
    cmp D[@uMsg],WM_PAINT
    jne >.defwindowproc
        invoke BeginPaint,[@hWnd],addr ps
        mov [hdc],eax

        invoke PaintProc,[@hWnd],[hdc]

        invoke EndPaint,[@hWnd],addr ps
        jmp >.exit

    .defwindowproc:
        ; Traitement par dfaut des autres messages Windows
        ; -------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .exit:

    mov eax,0
    ret
endf

;===========================================================================================
PaintProc frame @hWnd, @hDC
    local .caW:D
    local .caH:D
    local .tbH:D
    local .sbH:D

    invoke GetClientRect,[@hWnd],addr rect
    mov eax,[rect.right]
    mov [.caW],eax
    mov eax,[rect.bottom]
    mov [.caH],eax

    invoke GetWindowRect,[hToolBar],addr rect
    mov eax,[rect.bottom]
    sub eax,[rect.top]
    mov [.tbH],eax

    invoke GetWindowRect,[hStatus],addr rect
    mov eax,[rect.bottom]
    sub eax,[rect.top]
    mov [.sbH],eax

    mov eax,[.caH]
    sub eax,[.sbH]
    mov [.caH],eax

    mov D[rect.left],0
    mov eax,[.tbH]
    mov [rect.top],eax
    mov eax,[.caW]
    mov [rect.right],eax
    mov eax,[.caH]
    mov [rect.bottom],eax

    invoke DrawEdge,[@hDC],addr rect,EDGE_SUNKEN,BF_RECT

    mov eax,0
    ret
endf

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
.data

  Titre     db "Comctl32 Demo",0
  ClassName db ' GoAsm AsmGges Win32',0
  MsgAbout  db ' GoAsm AsmGges France @2006  ',0
  tb50      db "Nouveau fichier",0
  tb51      db "Ouvrir fichier",0
  tb52      db "Sauver fichier",0
  tb53      db "Couper",0
  tb54      db "Copier",0
  tb55      db "Coller",0
  tb56      db "Annuler",0
  tb57      db "Chercher",0
  tb58      db "Remplacer",0
  tb59      db "Imprimer",0
  TheText   db "SVP Confirmez Quitter",0
  tbSelect  db "Vous avez slectionn",0
  align 4

  WinX      dd 0
  WinY      dd 100
  WinW      dd 500
  WinH      dd 350

  hWnd      dd ?
  hdc       dd ?
  hMenu     dd ?
  hStatus   dd ?
  hToolBar  dd ?

  msg       MSG                  <>
  wc        WNDCLASS   < CS_HREDRAW+CS_VREDRAW+CS_BYTEALIGNWINDOW, addr WindowProc,\
                         0, 0, 0, 0, 0, COLOR_BTNFACE+1, 0, addr ClassName >
  ps        PAINTSTRUCT          <>
  rect      RECT                 <>
  tbb       TBBUTTON             <>
  Tba       TBADDBITMAP          <>
  icex      INITCOMMONCONTROLSEX <>

;===========================================================================================
